<template>
	<div class="vessel">
		<div class="vessel vis">
			<video
				class="video"
				src="../assets/images/bj1.mp4 "
				autoplay
				
				loop
			/>
			<p class="text">一个年轻人的音乐社交元宇宙</p>
		</div>

		<div class="sign">
			<div class="sign-head">
				<span>帐号登录</span>
			</div>
			<el-form
				ref="signInForm"
				status-icon
				:model="registerForm"
				:rules="SignInRules"
			>
				<el-form-item prop="username">
					<el-input
						placeholder="用户名"
						v-model="registerForm.username"
					></el-input>
				</el-form-item>
				<el-form-item prop="password">
					<el-input
						type="password"
						placeholder="密码"
						v-model="registerForm.password"
						@keyup.enter="handleLoginIn"
					></el-input>
				</el-form-item>
				<el-form-item class="sign-btn">
					<el-button @click="handleSignUp">注册</el-button>
					<el-button type="primary" @click="handleLoginIn">登录</el-button>
				</el-form-item>
			</el-form>
		</div>
	</div>
</template>

<script lang="ts">
import { defineComponent, reactive, getCurrentInstance } from "vue";
import mixin from "@/mixins/mixin";
import YinLoginLogo from "@/components/layouts/YinLoginLogo.vue";
import { HttpManager } from "@/api";
import { NavName, RouterName, SignInRules } from "@/enums";
import { useRouter } from "vue-router";

export default defineComponent({
	components: {
		YinLoginLogo,
	},
	setup() {
		const { proxy } = getCurrentInstance();
		const { routerManager, changeIndex } = mixin();

		// 登录用户名密码
		const registerForm = reactive({
			username: "",
			password: "",
		});

		async function handleLoginIn() {
			let canRun = true;
			(proxy.$refs["signInForm"] as any).validate((valid) => {
				if (!valid) return (canRun = false);
			});
			if (!canRun) return;

			const params = new URLSearchParams();
			params.append("username", registerForm.username);
			params.append("password", registerForm.password);

			try {
				const result = (await HttpManager.signIn(params)) as ResponseBody;
				(proxy as any).$message({
					message: result.message,
					type: result.type,
				});
				console.log(result.data[0]);

				await HttpManager.getState(1, result.data[0].id);
				if (result.success) {
					proxy.$store.commit("setUserId", result.data[0].id);
					proxy.$store.commit("setUsername", result.data[0].username);
					proxy.$store.commit("setUserPic", result.data[0].avator);
					proxy.$store.commit("setToken", true);
					changeIndex(NavName.Home);
					routerManager(RouterName.Home, { path: RouterName.Home });
				}
			} catch (error) {
				console.error(error);
			}
			// console.log(proxy.$store.state);
		}

		function handleSignUp() {
			changeIndex("注册");
			routerManager(RouterName.SignUp, { path: RouterName.SignUp });
		}

		return {
			registerForm,
			SignInRules,
			handleLoginIn,
			handleSignUp,
		};
	},
});
</script>

<style lang="scss" scoped>
@import "@/assets/css/sign.scss";
.sign {
	top: -540px;
}
.vessel {
	margin: 0;
	padding: 0;
	width: 100%;
	height: 100%;
}
.video {
	top: 20px;
	position:fixed;
	z-index: -1000;
	width: 100%;
	height: 100%;
}
.text {
	margin-top: 60px;
	z-index: 1000;
	text-align: center;
	
	font-size: 50px;
	background: linear-gradient(70deg, #4e72b8, pink);
	-webkit-background-clip: text;
	background-clip: text;
	color: transparent;
}
</style>
